#include "stdafx.h"
#include "DetectServer.h"


int GetIpAddress( char *ip_address, int bufsize )
{
	HOSTENT *lpHost; // zXgi[\
	IN_ADDR inaddr; //IPAhXi[\
	WSADATA wsadata;
	int i = 0;

	char szBuf[256];//, szIP[256]; // zXgێAIPAhXێ

	// Winsock̏
	if (WSAStartup(MAKEWORD(1, 1), &wsadata)) {
		//printf("WSAStartup֐sł\n");
		return -1;
	}

	/*
	printf("wVersion = %u\n", wsadata.wVersion);
	printf("wHighVersion = %u\n", wsadata.wHighVersion);
	printf("szDescription = %s\n", wsadata.szDescription);
	printf("szSystemStatus = %s\n", wsadata.szSystemStatus);
	printf("iMaxSockets = %d\n", wsadata.iMaxSockets);
	printf("iMaxUdpDg = %d\n", wsadata.iMaxUdpDg);
	*/

	// [J}ṼzXg擾
	gethostname(szBuf, (int)sizeof(szBuf));
//	printf("\nzXg=%s\n", szBuf);

	// zXg擾
	lpHost = gethostbyname(szBuf);
	/*
	for (i = 0; lpHost->h_addr_list[i]; i++) {
		//IPAhX擾
		memcpy(&inaddr, lpHost->h_addr_list[i], 4);
		strcpy(szIP, inet_ntoa(inaddr));
		printf("IPAhX=%s\n", szIP);
		TRACE("IPAhX=%s\n", szIP);
	}
	*/

	memcpy(&inaddr, lpHost->h_addr_list[0], 4);
	strcpy_s( ip_address, bufsize, inet_ntoa(inaddr) );

	// Winsock̔j
	WSACleanup();

	return 0;
}



// Ôׂ̂ė
void SendSameNamedData( Network *net, const vector<AR_OBJECT> &marker_info, DATA_ENABLE_LIST enable_list, string &name )
{
	char buf[1048];
	int num_found = 0;

	for (unsigned int i=0; i<marker_info.size(); i++) {
		if ( marker_info[i].name == name ) {
			num_found++;
		}
	}

//	sprintf_s( buf, sizeof(buf), "%d\n", num_found );
	sprintf_s( buf, sizeof(buf), "Num= %d\n", num_found );
	net->send_message(buf);

	for (unsigned int i=0; i<marker_info.size(); i++) {
		if ( marker_info[i].name == name ) {
			MakeMarkerInfoString( marker_info[i], enable_list, buf, sizeof(buf) );
			strcat_s( buf, sizeof(buf), "\n" );
			net->send_message(buf);
		}
	}
}

void SendAllData( Network *net, const vector<AR_OBJECT> &marker_info, DATA_ENABLE_LIST enable_list )
{
	char buf[1024];
	int num = marker_info.size();

//	sprintf_s( buf, sizeof(buf), "%d\n", num );
	sprintf_s( buf, sizeof(buf), "Num= %d\n", num );
	net->send_message(buf);

	for ( int j=0; j<num; j++) {
		MakeMarkerInfoString( marker_info[j], enable_list, buf, sizeof(buf) );
		strcat_s( buf, sizeof(buf), "\n");
		net->send_message(buf);
	}
}



void cvuDrawString( IplImage *image, const char *text, CvPoint pos, CvScalar color, double scale)
{
	CvFont dfont;
	double italicscale  = 0.0f;
    int    thickness;
	
	thickness = 4;
    cvInitFont( &dfont, CV_FONT_HERSHEY_DUPLEX, scale, scale,
				italicscale, thickness, CV_AA);
	cvPutText( image, text, pos, &dfont, CV_RGB(0,0,0) );

	thickness = 1;
	cvInitFont( &dfont, CV_FONT_HERSHEY_DUPLEX, scale, scale,
				italicscale, thickness, CV_AA);
	cvPutText( image, text, pos, &dfont, color );
}

int DrawMarkerLine( IplImage *image, AR_OBJECT &object, CvScalar color,
					int thickness, int line_type, int shift)
{
	// edge line
	CvPoint v[4];
	for (int i=0; i<4; i++) {
		v[i] = cvPoint( object.vertex[i][0], object.vertex[i][1] );
	}
	for (int i=0; i<4; i++) {
		cvLine( image, v[i], v[(i+1)%4], color, thickness, line_type, shift );
	}

	// direction vector
	CvPoint vec[2];
	for (int i=0; i<2; i++) {
		vec[i].x = v[i].x - object.px;
		vec[i].y = v[i].y - object.py;
	}
	CvPoint dvecpos;
	dvecpos.x = (vec[0].x + vec[1].x) + object.px;
	dvecpos.y = (vec[0].y + vec[1].y) + object.py;

	CvPoint center = cvPoint( object.px, object.py );
	cvLine( image, center, dvecpos, color, thickness, line_type, shift );

	return 0;
}

void DrawMarkerInfo( IplImage *image, AR_OBJECT &object )
{
	char text[256];
	DrawMarkerLine( image, object, CV_RGB(255,0,0), 1 );

	/*
	// vertex
	for (int i=0; i<4; i++) {
		char cbuf[256];
		sprintf_s( cbuf, sizeof(cbuf), "v%d", i );
		cvuDrawString( image, cbuf, cvPoint( object.vertex[i][0], object.vertex[i][1]), CV_RGB(255,0,0),0.5);
	}
	*/

	// coordinate value
	sprintf_s( text, sizeof(text), "(%d,%d)",(int)(object.px),(int)(object.py));
	cvuDrawString( image, text, cvPoint( object.px,  object.py ), CV_RGB(255,255,0), 0.5 );

	// name
	cvuDrawString( image, object.name.c_str(), cvPoint( object.px-10, object.py + 50 ), CV_RGB(255,255,255), 1.0 );
}


void Detection( IplImage* imgIn, IplImage *imgARTK, int thresh, const vector<PATTERN_DATA> &pattern_list, vector<AR_OBJECT> &detected_markers )
{
	cvCvtColor( imgIn, imgARTK, CV_BGR2BGRA );

	detected_markers.clear();	// important!
	DetectMarker( (ARUint8*)(imgARTK->imageData), thresh, pattern_list, detected_markers );
}


void MakeMarkerInfoString( const AR_OBJECT &object, DATA_ENABLE_LIST elist, char buf[], int bufsize )
{
	bool token = false;
	sprintf_s( buf, bufsize, "" );	// init string

	if (elist.name) {
		if (token) sprintf_s( buf, bufsize, "%s,", buf);
		sprintf_s( buf, bufsize, "%s%s" , buf, object.name.c_str() );
		token = true;
	}
	if (elist.pos2d) {
		if (token) sprintf_s( buf, bufsize, "%s,", buf);
		sprintf_s( buf, bufsize, "%s%d,", buf, (int)(object.px) );
		sprintf_s( buf, bufsize, "%s%d", buf, (int)(object.py) );
		token = true;
	}
	if (elist.dvec) {
		if (token) sprintf_s( buf, bufsize, "%s,", buf);
		sprintf_s( buf, bufsize, "%s%lf,", buf, object.dx );
		sprintf_s( buf, bufsize, "%s%lf" , buf, object.dy );
		token = true;
	}
	if (elist.pos3d) {
		if (token) sprintf_s( buf, bufsize, "%s,", buf);
		sprintf_s( buf, bufsize, "%s%lf,", buf, object.X  );
		sprintf_s( buf, bufsize, "%s%lf,", buf, object.Y  );
		sprintf_s( buf, bufsize, "%s%lf" , buf, object.Z  );
		token = true;
	}
	if (elist.area) {
		if (token) sprintf_s( buf, bufsize, "%s,", buf);
		sprintf_s( buf, bufsize, "%s%d" , buf, object.area );
		token = true;
	}
	if (elist.cf) {
		if (token) sprintf_s( buf, bufsize, "%s,", buf);
		sprintf_s( buf, bufsize, "%s%lf", buf, object.cf );
		token = true;
	}
	if (elist.vertex) {
		if (token) sprintf_s( buf, bufsize, "%s,", buf);
		for (int i=0; i<4; i++) {
			if (i>0) sprintf_s( buf, bufsize, "%s,", buf);
			sprintf_s( buf, bufsize, "%s%lf,", buf, object.vertex[i][0] );
			sprintf_s( buf, bufsize, "%s%lf",  buf, object.vertex[i][2] );
		}
		token = true;
	}
	if (elist.glmatrix) {
		if (token) sprintf_s( buf, bufsize, "%s,", buf);
		for (int i=0; i<16; i++) {
			if (i>0) sprintf_s( buf, bufsize, "%s,", buf);
			sprintf_s( buf, bufsize, "%s%lf", buf, object.gltrans[i] );
		}
		token = true;
	}
}

void MakeDataFormatString( DATA_ENABLE_LIST elist, char buf[], int bufsize )
{
	bool token = false;
	sprintf_s( buf, bufsize, "" );	// init string

	if (elist.name) {
		if (token) sprintf_s( buf, bufsize, "%s,", buf);
		sprintf_s( buf, bufsize, "%s<name>", buf);
		token = true;
	}
	if (elist.pos2d) {
		if (token) sprintf_s( buf, bufsize, "%s,", buf);
		sprintf_s( buf, bufsize, "%s<px>,<py>", buf);
		token = true;
	}
	if (elist.dvec) {
		if (token) sprintf_s( buf, bufsize, "%s,", buf);
		sprintf_s( buf, bufsize, "%s<dx>,<dy>", buf);
		token = true;
	}
	if (elist.pos3d) {
		if (token) sprintf_s( buf, bufsize, "%s,", buf);
		sprintf_s( buf, bufsize, "%s<X>,<Y>,<Z>", buf);
		token = true;
	}
	if (elist.area) {
		if (token) sprintf_s( buf, bufsize, "%s,", buf);
		sprintf_s( buf, bufsize, "%s<area>" , buf);
		token = true;
	}
	if (elist.cf) {
		if (token) sprintf_s( buf, bufsize, "%s,", buf);
		sprintf_s( buf, bufsize, "%s<cf>", buf);
		token = true;
	}
	if (elist.vertex) {
		if (token) sprintf_s( buf, bufsize, "%s,", buf);
		for (int i=0; i<4; i++) {
			if (i>0) sprintf_s( buf, bufsize, "%s,",buf);
			sprintf_s( buf, bufsize, "%s<vx%d>,<vy%d>", buf,i,i);
		}
		token = true;
	}
	if (elist.glmatrix) {
		if (token) sprintf_s( buf, bufsize, "%s,", buf);
		for (int i=0; i<16; i++) {
			if (i>0) sprintf_s( buf, bufsize, "%s,", buf);
			//sprintf_s( buf, bufsize, "%s<m%d>", buf, i );
			int a = i%4 + 1;
			int b = (int)(i/4) + 1;
			sprintf_s( buf, bufsize, "%s<m%d%d>", buf, a, b );			
		}
		token = true;
	}
}